
#ifndef _LCD_C_
#define _LCD_C_

#include "main.h"

#define LCD_16X1 1
#define LCD_16X2 2
#define LCD_16X4 3
#define LCD_40X2 4
#define LCD_16X1_B 5 // 16x2 LCD arranged like 8x2

#define LCD_TYPE LCD_16X1_B

//#define RW_PORT		PORTA
#define E_PORT		PORTC
#define RS_PORT		PORTC
#define DATA_PORT	PORTD
#define DATA_DDR	DDRD
#define DATA_INPUT	PIND

//#define RW_PIN		PD2
#define E_PIN		PC3
#define RS_PIN		PC2
#define DATA_PIN	PD0

#define LCD_USE_READ_FUNCTION	0

#define DATA_PORT_MASK (~(0x0F << DATA_PIN))

#define SHOW_CURSEL	0

// Initialize LCD
void LCD_Init(void);
void LCD_Clear(void);
// 1-byte transfer
void LCD_Transfer_Write(uint8_t data, uint8_t rs, uint8_t upper4);

#if (LCD_USE_READ_FUNCTION)
// 1-byte transfer
void LCD_Transfer_Read(uint8_t* data, uint8_t rs);
#endif

void LCD_SetTextPos(uint8_t pos);
void LCD_Print(const char* text, uint8_t size);
void LCD_BusyCheck(void);
//void LCD_PrintBCD(const uint16_t bcd);
void LCD_Putc(char d);

void LCD_SetCGRAM(uint8_t startAddr, const uint8_t* font, uint8_t size);

#endif
