#pragma once

// Fuse: -fl11110100 -fh11010001

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>  /* for sei(), timer0 */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/eeprom.h>

#include <avr/pgmspace.h>   /* required by usbdrv.h */

#include <stdint.h>
#include "YSwitchProc.h"
#include "lcd.h"

#define SHUTDOWN_THRESHOLD (10*60) // auto shut down time (sec.)
#define DUTY_CHANGE_METHOD 1 // 0: same current different duty, 1: multiply current if available

struct sPreference{
	uint16_t current;
	uint8_t  duty, display; // index
	uint16_t timer1_max;
};
void LoadEEPSetting(struct sPreference* pSetting);
void SaveEEPSetting(const struct sPreference* pSetting);
extern struct sPreference g_preference;

void LCDMessageUpdate(const struct sPreference* pPreference);
void CalibrationRoutine(uint8_t swState, struct sPreference* pPreference);
void SwitchRoutine(uint8_t swState, struct sPreference* pPreference);
void UpdatePWMTimer(const struct sPreference* pPreference);
void Shutdown(void);

void LCD_PrintBCD(uint16_t num);
